PROGRAM ReeAccess2;

USES WinTypes, WinProcs, WObjects, ReeFace;

{$R ReeXs2}

TYPE
  PMyWindow = ^TMyWindow;
  TMyWindow = OBJECT (TWindow)
    CONSTRUCTOR Init (AParent: PWindowsObject; ATitle: PChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE Destroy; VIRTUAL;
    PROCEDURE GetWindowClass (VAR AWndClass: TWndClass); VIRTUAL;
    PROCEDURE WMTimer (VAR Msg: TMessage); VIRTUAL wm_First + wm_Timer;
  END;

  TMyApplication = OBJECT (TApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

CONSTRUCTOR TMyWindow.Init (AParent: PWindowsObject; ATitle: PChar);
BEGIN
  TWindow.Init (AParent, ATitle);
  Attr.w := 200;
  Attr.h := 70;
END;

PROCEDURE TMyWindow.SetupWindow;
BEGIN
  TWindow.SetupWindow;
  SetTimer (HWindow, 2, 300, NIL);
END;

PROCEDURE TMyWindow.Destroy;
BEGIN
  KillTimer (HWindow, 2);
  TWindow.Destroy;
END;

PROCEDURE TMyWindow.GetWindowClass (VAR AWndClass: TWndClass);
BEGIN
  TWindow.GetWindowClass (AWndClass);
  AWndClass.hIcon := LoadIcon (hInstance, idi_Asterisk);
END;

PROCEDURE TMyWindow.WMTimer (VAR Msg: TMessage);
VAR
  EinDC: HDC;
  Temporary: WORD;
  APChar: ARRAY [0..22] OF CHAR;
BEGIN
  IF (Msg.wParam = 2)
  THEN BEGIN
    InvalidateRect (HWindow, NIL, False);
    EinDC := GetDC (HWindow);
    Temporary := ReeFace.GetValue;
    WVSPrintF (APChar, '%3u', Temporary);
    TextOut (EinDC, 5, 10, APChar, 3);
    ReleaseDC (HWindow, EinDC);
  END;
END;

PROCEDURE TMyApplication.InitMainWindow;
BEGIn
  MainWindow := New (PMyWindow, Init(NIL, 'Current Value'));
END;

VAR
  GenericApp: TMyApplication;

BEGIN
  GenericApp.Init ('ReeAccess 2');
  GenericApp.Run;
  GenericApp.Done;
END.